        include "doorsos.h"
	include	"hexlib.h"


	xdef	_main
        xdef    _ti92plus                                        


;*****************************************************

_main:


        clr.w           doorsos::kb_globals+$1C

        move.w          #0,-(a7)
        jsr             doorsos::FontSetSys
        addq.w          #2,a7

        move.w          #4,-(a7)
        pea             Truc(pc)
        move.w          #55,-(a7)        	; y
        move.w          #2,-(a7)       		; x 
        ROM_CALL 	$1A9			;doorsos::DrawStrXY
        lea             10(a7),a7
	

        move.w          #4,-(a7)
        pea             Keys(pc)
        move.w          #72,-(a7)        	; y
        move.w          #16,-(a7)       		; x 
        ROM_CALL 	$1A9			;doorsos::DrawStrXY
        lea             10(a7),a7

	
MainLoop:
        tst.w           doorsos::kb_globals+$1C
        beq             NoKey
        move.w          doorsos::kb_globals+$1E,d2
        clr.w           doorsos::kb_globals+$1C

        cmp.w           #$108,d2
        beq             exit
	
	lea.l		KeyCode(PC),a0
	move.w		#11,d1
KeyScanLoop:
	move.w		(a0)+,d0
	cmp.w		d0,d2
	beq		KeyChange
	dbra		d1,KeyScanLoop

NoKey:
	clr.L		d0
	clr.l		d1
	move.l		#2,d6
	lea.l		RegAdress(PC),a0
	moveq		#2,d5
DispRegLoop:
	move.l		d6,d2
	move.l		(a0)+,a1
      	move.w          (a1),d0             
	move.l		#8,d1
	move.l		#3,d4
	jsr		hexlib::put_bin
	clr.L		d0
	add.l		#8,d6
	dbra		d5,DispRegLoop
	bra		MainLoop

KeyChange:
	move.w		#12,d2
	addq		#1,d1
	sub.w		d1,d2		
	divu.w		#4,d2
	move.w		d2,d1
	swap		d2
	lea.l		KeyMask(PC),a0
	lea.l		RegAdress(PC),a1
	lsl.w		#2,d1
	lsl.w		#1,d2
	add.w		d1,a1
	move.l		(a1),a3
	add.w		d2,a0
	move.w		(a0),d2

	move.w		(a3),d1
	eor.w		d2,d1
	move.w		d1,(a3)
	
	bra		MainLoop


;********************************	
exit:
	rts



;*****************************************************
; miscellaneous program data
;*****************************************************

	EVEN
RegAdress	dc.l	$C0001A,$C0001C,$C0001E
;RegAdress	dc.l	$200,$202,$204

	EVEN
KeyCode		dc.w	'q','w','e','r','t','y','u','i','7','8','9','*'
KeyMask		dc.w	%1000,%0100,%0010,%0001

Truc	    dc.b    "30s IRQ BUSY HOLD     t1 t0 INT MASK      TEST 24 STP RST",0 
Keys	    dc.b    "Q W  E  R                  T  Y  U   I                  7  8  9  *",0 




;*****************************************************

	end
