
	include "72423.h"

	xdef	_main
	xdef	_ti92plus	
	xdef	_nostub
;*****************************************************
_ti92plus:
_nostub:

LCD_MEM equ     $4C00

DEREF   macro   ; Dn,An
        lsl.w   #2,\1
;        move.l  doorsos::Heap,\2
        move.l  $7592,\2
        move.l  0(\2,\1.w),\2
        endm

ROM_CALL macro
        move.l ($C8),a4
        add.l #\1*4,a4
        move.l (a4),a4
        jsr (a4)
        endm

_main:
	movem.l 	d0-d7/a0-a6,-(a7)

	


        move.l          $78,OldAutoInt6
	move.b		#-1,Test
	move.l		#NewAutoInt6,$40078
	move.l		#0,d0
	move.w		#4,RegE	
	
	
WaitForStart:
	tst.b		Test
	beq		WaitForStart
	
SpeedLoop:

	add.l		#1,d0
	cmp.b		#2,Test
	bne		SpeedLoop
	
	move.w		#5,RegE	

	move.l        	OldAutoInt6,$40078
	
	move.l		#0,d1
	move.l		#0,d2
	move.l		#7,d4
	bsr		put_hex	
	

	movem.l 	(a7)+,d0-d7/a0-a6
        rts


NewAutoInt6:
	clr.b   	($60001a)          	;dbloque ON pour int 6
	lea.l		Test(PC),a0
	add.b		#1,(a0)
	
        rte

	include hexlib.asm



	EVEN

RegAdress	dc.l	$C0001A,$C0001C,$C0001E
OldAutoInt6     dc.l    0
Test	dc.b	0
        EVEN


;*****************************************************

	end
